Halide 22.0.0 Halide compiler and libraries

Loading...
Searching...
No Matches
Classes | Public Member Functions | Static Public Attributes | List of all members
Halide::Internal::IRMatcher::WildConst< i > Struct Template Reference

`#include <IRMatch.h>`

## Classes
struct | pattern_tag

## Public Member Functions
template<uint32_t bound>
HALIDE_ALWAYS_INLINE bool | match (const BaseExprNode &e, MatcherState &state) const noexcept
template<uint32_t bound>
HALIDE_ALWAYS_INLINE bool | match (int64_t e, MatcherState &state) const noexcept
HALIDE_ALWAYS_INLINE Expr | make (MatcherState &state, halide_type_t type_hint) const
HALIDE_ALWAYS_INLINE void | make_folded_const (halide_scalar_value_t &val, halide_type_t &ty, MatcherState &state) const noexcept

## Static Public Attributes
static constexpr uint32_t | binds = 1 << i
static constexpr IRNodeType | min_node_type = IRNodeType::IntImm
static constexpr IRNodeType | max_node_type = IRNodeType::FloatImm
static constexpr bool | canonical = true
static constexpr bool | foldable = true

## Detailed Description

template<int i>
struct Halide::Internal::IRMatcher::WildConst< i >

Definition at line 396 of file IRMatch.h.

## Member Function Documentation

## ◆ match() [1/2]

template<int i>
template<uint32_t bound>

HALIDE_ALWAYS_INLINE bool Halide::Internal::IRMatcher::WildConst< i >::match | ( | const BaseExprNode & | e,
|  | MatcherState & | state
| ) |  | const
| inline noexcept

Definition at line 406 of file IRMatch.h.

References Halide::Internal::Broadcast, Halide::Internal::IRMatcher::cast(), Halide::Internal::FloatImm, Halide::Internal::IntImm, Halide::Internal::IRMatcher::max_wild, Halide::Internal::IRNode::node_type, and Halide::Internal::UIntImm.

## ◆ match() [2/2]

template<int i>
template<uint32_t bound>

HALIDE_ALWAYS_INLINE bool Halide::Internal::IRMatcher::WildConst< i >::match | ( | int64_t | e,
|  | MatcherState & | state
| ) |  | const
| inline noexcept

Definition at line 425 of file IRMatch.h.

References Halide::Internal::IRMatcher::cast(), and Halide::Internal::IRMatcher::max_wild.

## ◆ make()

template<int i>

HALIDE_ALWAYS_INLINE Expr Halide::Internal::IRMatcher::WildConst< i >::make | ( | MatcherState & | state,
|  | halide_type_t | type_hint
| ) |  | const
| inline

Definition at line 431 of file IRMatch.h.

References Halide::Internal::IRMatcher::cast(), Halide::Internal::IRMatcher::MatcherState::get_bound_const(), and Halide::Internal::IRMatcher::make_const_expr().

## ◆ make_folded_const()

template<int i>

HALIDE_ALWAYS_INLINE void Halide::Internal::IRMatcher::WildConst< i >::make_folded_const | ( | halide_scalar_value_t & | val,
|  | halide_type_t & | ty,
|  | MatcherState & | state
| ) |  | const
| inline noexcept

Definition at line 441 of file IRMatch.h.

References Halide::Internal::IRMatcher::cast().

## Member Data Documentation

## ◆ binds

template<int i>

constexpr uint32_t Halide::Internal::IRMatcher::WildConst< i >::binds = 1 << i
| static constexpr

Definition at line 399 of file IRMatch.h.

## ◆ min_node_type

template<int i>

constexpr IRNodeType Halide::Internal::IRMatcher::WildConst< i >::min_node_type = IRNodeType::IntImm
| static constexpr

Definition at line 401 of file IRMatch.h.

## ◆ max_node_type

template<int i>

constexpr IRNodeType Halide::Internal::IRMatcher::WildConst< i >::max_node_type = IRNodeType::FloatImm
| static constexpr

Definition at line 402 of file IRMatch.h.

## ◆ canonical

template<int i>

constexpr bool Halide::Internal::IRMatcher::WildConst< i >::canonical = true
| static constexpr

Definition at line 403 of file IRMatch.h.

## ◆ foldable

template<int i>

constexpr bool Halide::Internal::IRMatcher::WildConst< i >::foldable = true
| static constexpr

Definition at line 438 of file IRMatch.h.

The documentation for this struct was generated from the following file:

- src/IRMatch.h